/**
 * 通用接口
 */

!(function (o) { 
    'use strict';
    var API = SFAPI,
        log = SFLOG,
        G = SFConfig,
        fullURL = '',
        ecConfig = SF.ecConfig;
    o.container = o.container || {};

    //拼接个人目录和公共目录子级相关的信息
    function getFullPath (options, next) {
        var browserType = 0;
        function initToken () {
            SF.common.initLocalPage({
                success: function () {
                    getVpnURL();
                },
                error: function (res) {
                    options.error(res);
                    log.debug('BUSINESS: initToken', 'initToken is fail cause by network is fail');
                    next();
                }
            });
        }

        function getVpnURL () {
            SFAPI.getTempData({
                type:G.CACHE_TYPE.ECAGENT,
                key:G.CACHE_PREFIX,
                success:function (res) {
                    if (!res && !res.data && !res.data.vpnURL) {
                        return;
                    }
                    browserType = parseInt(res.data.browserType, 10);
                    fullURL = res.data.vpnURL + '/por/shortcut.csp?type=cs&destUrl=webfs.csp';
                    getTwfID();
                },
                error:function (res) {
                    options.error(res);
                    log.debug('BUSINESS: getVpnURL', 'getVpnURL is fail cause by network is fail');
                    next();
                }
            });
        }

        function getTwfID() {

            SFAPI.invokeContainerAPI({
                name: 'ecReadConfig',
                params: {key: 'twfID'},
                success: function (res) {
                    if (!res && !res.data) {
                        return;
                    }
                    fullURL += '&id=' + res.data;

                    //获取语言
                    getLanguage();
                },
                error: function (res) {
                    options.error(res);
                    log.debug('BUSINESS: ecGetter', 'ecGetter twfid is fail cause by network is fail');
                    next();
                }
            });
        }

        function getLanguage () {
            var lang;
            SFAPI.invokeContainerAPI({
                name: 'ecReadConfig',
                params: {key: 'lang'},
                success: function (res) {
                    if (!res && !res.data) {
                        return;
                    }

                    //返回为空设置成中文
                    lang = res.data || 'zh_CN';
                    fullURL += '&language=' + lang;

                    //获取ec_port
                    getEcPort();
                },
                error: function (res) {
                    options.error(res);
                    log.debug('BUSINESS: ecGetter', 'ecGetter language is fail cause by network is fail');
                    next();
                }
            });
        }

        function getEcPort () {
            SFAPI.invokeContainerAPI({
                name: 'ecReadConfig',
                params: {key: 'ecPort'},
                success: function (res) {
                    var storeData;
                    if (!res && !res.data) {
                        return;
                    }
                    fullURL += '&ea_port=' + res.data;

                    //拼接动态后续三个字段
                    fullURL += '&rapp_storage_id=' + options.rapp_storage_id + '&rcid=' + options.rcid + '&is_reminded=' + options.is_reminded;
                    storeData = {
                        code: 1,
                        data: {
                            fullURL: fullURL,
                            browserType: browserType
                        }
                    };
                    options.success(storeData);
                    next();
                },
                error: function (res) {
                    options.error(res);
                    log.debug('BUSINESS: ecGetter', 'ecGetter language is fail cause by network is fail');
                    next();
                }
            });
        }
        initToken();
    }
    


    /**
     * 拼接浏览器访问地址
     * @param {object} options 
     *  options.success {function} 
     *  options.error {function} 
     * @param {object} events 
     */
    o.container.getFullPath = function (options, events) {
        new SFCommon.BaseAPI(options, events, getFullPath).invoke();
    };

    o.container.invokeAPI = SFAPI.invokeContainerAPI;
})(SF);
